"""
Django settings for resa project.

Generated by 'django-admin startproject' using Django 1.10.

For more information on this file, see
https://docs.djangoproject.com/en/1.10/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/1.10/ref/settings/
"""

import ast
import os

import dj_database_url
from django.contrib import messages
from django.urls import reverse_lazy
from django.utils.translation import gettext_lazy as _

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))

# DEBUG ?
# Retrieve environment
ENV = os.getenv("DJANGO_ENV", "prod")
DEBUG = os.getenv("DEBUG", "False") == "True"

# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/1.10/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.getenv(
    "SECRET_KEY", "r6=0@#g#py60s2ujq=03^^w^8*mh_!a7wpou_fu7&&40p3r+(o"
)

# Liste des noms de domaines authorisé à appeler le site.
# Ajoute ".bde-insa-lyon.fr" si la variable d'environnement n'est spécifié.
ALLOWED_HOSTS = [
    "localhost",
    "web",
    os.getenv("DJANGO_ALLOWED_HOST", ".bde-insa-lyon.fr"),
]

ADMINS = [
    ("Équipe SIA", os.getenv("ADMIN_EMAIL")),
]
SERVER_EMAIL = os.getenv("SERVER_EMAIL")
EMAIL_SUBJECT_PREFIX = "[Resa] "

# Application definition

INSTALLED_APPS = [
    "account",
    "permissions",
    "crispy_forms",
    "crispy_bootstrap5",
    "bookings",
    "anymail",
    "django_crontab",
    "django.contrib.admin",
    "django.contrib.auth",
    "django.contrib.contenttypes",
    "django.contrib.sessions",
    "django.contrib.messages",
    "django.contrib.staticfiles",
    "django.contrib.humanize",
    "django.contrib.postgres",
    "coverage",
]

MIDDLEWARE = [
    "django.middleware.security.SecurityMiddleware",
    "whitenoise.middleware.WhiteNoiseMiddleware",
    "django.contrib.sessions.middleware.SessionMiddleware",
    "django.middleware.locale.LocaleMiddleware",
    "django.middleware.common.CommonMiddleware",
    "django.middleware.csrf.CsrfViewMiddleware",
    "django.contrib.auth.middleware.AuthenticationMiddleware",
    "django.contrib.messages.middleware.MessageMiddleware",
    "django.middleware.clickjacking.XFrameOptionsMiddleware",
]

CSRF_TRUSTED_ORIGINS = [
    "http://localhost",
    "http://127.0.0.1",
    os.getenv("CSRF_SITE", "https://resa.bde-insa-lyon.fr"),
]

SECURE_CONTENT_TYPE_NOSNIFF = False
SECURE_REFERRER_POLICY = ""

ROOT_URLCONF = "resa.urls"

TEMPLATES = [
    {
        "BACKEND": "django.template.backends.django.DjangoTemplates",
        "DIRS": ["templates"],
        "APP_DIRS": True,
        "OPTIONS": {
            "context_processors": [
                "django.template.context_processors.debug",
                "django.template.context_processors.request",
                "django.contrib.auth.context_processors.auth",
                "django.contrib.messages.context_processors.messages",
                "bookings.processors.resource_and_category_list",
            ],
        },
    },
]

WSGI_APPLICATION = "resa.wsgi.application"

LOG_LEVEL = "DEBUG" if DEBUG else "INFO"

LOGGING = {
    "version": 1,
    "disable_existing_loggers": False,
    "handlers": {
        "console": {
            "class": "logging.StreamHandler",
        },
    },
    "loggers": {
        "bookings": {"handlers": ["console"], "level": LOG_LEVEL},
    },
}

# Database
# https://docs.djangoproject.com/en/1.10/ref/settings/#databases

DATABASES = {
    "default": {
        "ENGINE": "django.db.backends.sqlite3",
        "NAME": os.path.join(BASE_DIR, "db.sqlite3"),
    }
}

db_from_env = dj_database_url.config(conn_max_age=500)
DATABASES["default"].update(db_from_env)

# Password validation
# https://docs.djangoproject.com/en/1.10/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        "NAME": "django.contrib.auth.password_validation.UserAttributeSimilarityValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.MinimumLengthValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.CommonPasswordValidator",
    },
    {
        "NAME": "django.contrib.auth.password_validation.NumericPasswordValidator",
    },
]

# Internationalization
# https://docs.djangoproject.com/en/1.10/topics/i18n/

LANGUAGE_CODE = os.getenv("DJANGO_LOCALE", "fr")

TIME_ZONE = os.getenv("DJANGO_TIMEZONE", "Europe/Paris")

USE_I18N = True

USE_TZ = False

LOCALE_PATHS = [
    os.path.join(BASE_DIR, "locale"),
]

LANGUAGES = [
    ("fr", _("French")),
    ("en", _("English")),
]

# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/1.10/howto/static-files/
STATIC_ROOT = os.path.join(BASE_DIR, "staticfiles")
STATIC_URL = "/static/"

# Extra places for collectstatic to find static files.
STATICFILES_DIRS = (
    # os.path.join(BASE_DIR, 'codes', 'static'),
    "static",
)

# Media files (uploaded by users)
MEDIA_ROOT = os.path.join(BASE_DIR, "uploads")
MEDIA_URL = "/uploads/"

LOGIN_URL = reverse_lazy("oauth_login", kwargs={"provider": "microsoft"})
LOGOUT_URL = "logout"
LOGIN_REDIRECT_URL = "bookings:home"
LOGOUT_REDIRECT_URL = "bookings:home"

# DEFAULT_AUTO_FIELD spécifie une classe de clef primaire implicite, i.e. quand aucune clef primaire n'est spécifiée
DEFAULT_AUTO_FIELD = "django.db.models.AutoField"

CRISPY_ALLOWED_TEMPLATE_PACK = (
    "bootstrap",
    "uni_form",
    "bootstrap5",
)

CRISPY_TEMPLATE_PACK = "bootstrap5"

AUTH_USER_MODEL = "permissions.User"

MESSAGE_TAGS = {messages.ERROR: "danger"}
KEYCLOAK_ENDPOINT = os.getenv(
    "KEYCLOAK_ENDPOINT",
    "http://192.168.0.25/auth/realms/asso-insa-lyon/protocol/openid-connect/token",
)
ADHESION_URL = os.environ.get("ADHESION_URL", "http://localhost:8000")
ADHESION_CLIENT_ID = os.getenv("ADHESION_CLIENT_ID", "resa")
ADHESION_CLIENT_SECRET = os.getenv(
    "ADHESION_CLIENT_SECRET", "bc24c184-8415-4454-8342-e6daf16f905d"
)

# Email backend configuration
if os.environ.get("EMAIL_BACKEND", "mailjet") == "console":
    import sys

    EMAIL_BACKEND = "django.core.mail.backends.console.EmailBackend"
    print("Using console email backend", file=sys.stderr)
else:
    EMAIL_BACKEND = "anymail.backends.mailjet.EmailBackend"

ANYMAIL = {
    "MAILJET_API_KEY": os.getenv("MAILJET_API_KEY"),
    "MAILJET_SECRET_KEY": os.getenv("MAILJET_SECRET_KEY"),
}

DEFAULT_FROM_EMAIL = os.environ.get("DEFAULT_FROM_EMAIL", "")

# Send a reminder email every 2 hours for reservations which will end soon
CRONJOBS = [("1 */2 * * *", "bookings.cron.send_reminder_email")]
